function [psiR_grid,QR_grid,psiRa_grid,QRa_grid,C_grid,Cp_grid,alpha_gridf] = RecLCPCnum(psiR_grid,QR_grid,psiRa_grid,QRa_grid,C_grid,Cp_grid,alpha_gridf,XR_grid,R_grid,wR_grid,FR_grid,fR_grid,A_grid,alpha_grid,par,G,u,u1,up,upp,up1,T,i,A_min);
beta = par(6); r = par(5); Rf = exp(r); mur = par(13); sigmar = par(14); Ret = par(end); eta = par(8); lambda = par(9); gamma = par(10); m = size(R_grid,1); n = size(A_grid,1); o = size(alpha_grid,1); theta = par(7);
U = 0; if size(wR_grid,1)>1; U = 1; R1_grid = R_grid; end; w_grid = wR_grid; F_grid = FR_grid;
% psi = griddedInterpolant({[A_grid],alpha_grid},[psiR_grid(:,:,i-1)]); psi = @(A,alpha) max(psi(A,alpha),-1./psi(A,alpha));
% Q = griddedInterpolant({[A_grid],alpha_grid},[QR_grid(:,:,i-1)]); Q = @(A,alpha) max(Q(A,alpha),-1./Q(A,alpha));
% psipa = griddedInterpolant({[A_grid],alpha_grid},[psiRa_grid(:,:,i-1)]);
% Qpa = griddedInterpolant({[A_grid],alpha_grid},[QRa_grid(:,:,i-1)]);
psi = griddedInterpolant({[0; A_grid; 10*A_grid(end)],alpha_grid},[psiR_grid(1,:,i-1); psiR_grid(:,:,i-1); psiR_grid(end,:,i-1)]);
Q = griddedInterpolant({[0; A_grid; 10*A_grid(end)],alpha_grid},[QR_grid(1,:,i-1); QR_grid(:,:,i-1); QR_grid(end,:,i-1)]);
psipa = griddedInterpolant({[0; A_grid; 10*A_grid(end)],alpha_grid},[psiRa_grid(1,:,i-1); psiRa_grid(:,:,i-1); psiRa_grid(end,:,i-1)]);
Qpa = griddedInterpolant({[0; A_grid; 10*A_grid(end)],alpha_grid},[QRa_grid(1,:,i-1); QRa_grid(:,:,i-1); QRa_grid(end,:,i-1)]);
N = n; Rp = @(R,alpha) Rf+alpha.*(R-Rf);
for a = 1:o; alpha_par_grid = alpha_gridf(:,:,a,i-1); C_par_grid = C_grid(:,:,a,i-1); Cp_par_grid = zeros(m,n); par_grid = alpha_gridf(:,:,a,i-1);
    for k = 1:n; Xend_grid = zeros(N,1); Cend_grid = Xend_grid; Cgrid_start = Cend_grid; % parfor for parallel computing
        Aend_grid = (A_grid+(A_grid(k)-A_grid(1))).*(0.5:1/(n-1):1.5)';
        % if i == Ret; Aend_grid = (A_grid+(A_grid(k)-A_grid(1))).*(0.001:1/(n-1):1.001)'; end;
        alphaend_grid = linspace(par_grid(1,k),par_grid(end,k),N)';
        Xend_grid = Aend_grid+up1((Aend_grid.^(-theta).*psi(Aend_grid,alphaend_grid)));
        if U == 0; FR_grid = normcdf(log(max((Xend_grid/A_grid(k)/G(i)-Rf)/alpha_grid(a)+Rf,0.00001)),mur,sigmar);
        else FR_grid = interp1([0; squeeze(XR_grid((diff(XR_grid(:,k,a))>0),k,a)); XR_grid(end,k,a)*10],[0; squeeze(F_grid((diff(XR_grid(:,k,a))>0),k,a)); 1],Xend_grid,'linear','extrap'); FR_grid = min(max(FR_grid,0),1);
        end;
        t = 0; threshold = 1;
        while threshold>0.01 && t<15
            if i>Ret; for j = 1:N
                if a==1; alphaend_grid(j) = fminbnd(@(alpha) abs(psipa(Aend_grid(j),alpha)),0,1); else alphaend_grid(j) = fminbnd(@(alpha) abs((psipa(Aend_grid(j),alpha)+gamma*Qpa(Aend_grid(j),alpha).*(eta*FR_grid(j)+eta*lambda*(1-FR_grid(j))))),0,1); end;
            end; else; alphaend_grid = interp1([0; squeeze(XR_grid((diff(XR_grid(:,k,a))>0),k,a)); XR_grid(end,k,a)*10],[0; squeeze(alpha_gridf((diff(XR_grid(:,k,a))>0),k,a)); 1],Xend_grid,'linear','extrap'); end;
            if a==1; Cend_grid = up1((Aend_grid.^(-theta).*psi(Aend_grid,alphaend_grid))); else Cend_grid = up1((Aend_grid.^(-theta).*psi(Aend_grid,alphaend_grid)+gamma*Aend_grid.^(-theta).*Q(Aend_grid,alphaend_grid).*(eta*FR_grid+eta*lambda*(1-FR_grid)))./(1+eta*FR_grid+eta*lambda*(1-FR_grid))); end;
            Xend_grid = Cend_grid+Aend_grid; threshold = sum(abs(Cend_grid-Cgrid_start)); Cgrid_start = Cend_grid;
            if U == 0; % FR_grid = normcdf(log(max((Xend_grid/A_grid(k)/G(i)-Rf)/alpha_grid(a)+Rf,0.00001)),mur,sigmar);
            FR_grid = interp1([0; squeeze(XR_grid((diff(XR_grid(:,k,a))>0),k,a)); XR_grid(end,k,a)*10],[0; squeeze(F_grid((diff(XR_grid(:,k,a))>0))); 1],Xend_grid,'linear','extrap'); FR_grid = min(max(FR_grid,0),1);
            else FR_grid = interp1([0; squeeze(XR_grid((diff(XR_grid(:,k,a))>0),k,a)); XR_grid(end,k,a)*10],[0; squeeze(F_grid((diff(XR_grid(:,k,a))>0),k,a)); 1],Xend_grid,'linear','extrap'); FR_grid = min(max(FR_grid,0),1);
            end;
            if sum(FR_grid)>N-N/2 || sum(FR_grid)<N/2 || i == Ret && t<10; [Xend_grid,ix] = sort(Xend_grid); Cend_grid = Cend_grid(ix); alphaend_grid = alphaend_grid(ix);
                C_par_grid(:,k) = interp1([0; squeeze(Xend_grid(diff(Xend_grid)>0)); Xend_grid(end)*10],[0; squeeze(Cend_grid(diff(Xend_grid)>0)); Cend_grid(end)*10],XR_grid(:,k,a),'linear','extrap');
                Aend_grid = max(XR_grid(:,k,a)-C_par_grid(:,k),zeros(m,1)); Aend_grid = sort(Aend_grid); fi = find(Aend_grid,1); 
                Aend_grid = (A_grid+(A_grid(k)-A_grid(1))).*(0.5:1/(n-1):1.5)';
                % Aend_grid = linspace(Aend_grid(fi),Aend_grid(end),N)'.*(0.05:1/(N-1):1.05)';
                if a == 1; fi = N; Aend_grid = Aend_grid(round(N/2)).*(2/fi:2/fi:2)'; Aend_grid = linspace(log(1+log(1+log(1+Aend_grid(1)))),log(1+log(1+log(1+Aend_grid(end)))),N)'; Aend_grid = exp(exp(exp(Aend_grid)-1)-1)-1; end;
                % take the log thingy with A out?
            end; t = t+1;
        end
        if a==1; Cend_grid = up1((Aend_grid.^(-theta).*psi(Aend_grid,alphaend_grid))); else Cend_grid = up1((Aend_grid.^(-theta).*psi(Aend_grid,alphaend_grid)+gamma*Aend_grid.^(-theta).*Q(Aend_grid,alphaend_grid).*(eta*FR_grid+eta*lambda*(1-FR_grid)))./(1+eta*FR_grid+eta*lambda*(1-FR_grid))); end;
        Xend_grid = Cend_grid+Aend_grid; 
        [Xend_grid,ix] = sort(Xend_grid); Cend_grid = Cend_grid(ix); Aend_grid = Aend_grid(ix); alphaend_grid = alphaend_grid(ix);
        C_par_grid(:,k) = interp1([0; Xend_grid; Xend_grid(end)*10],[0; Cend_grid; Cend_grid(end)*10],XR_grid(:,k,a),'linear','extrap');
        if i>Ret; alpha_par_grid(:,k) = interp1([Xend_grid],[alphaend_grid],XR_grid(:,k,a),'linear','extrap'); alpha_par_grid(:,k) = min(max(alpha_par_grid(:,k),0),1);
        else alpha_par_grid(:,k) = alpha_gridf(:,k,a,i); end;
        % [alphaend_grid Xend_grid XR_grid(:,k,a) Cend_grid FR_grid alpha_par_grid(:,k)]
        Ap = @(X) interp1([0; Xend_grid],[0; Aend_grid],X,'linear','extrap'); Ap = @(X) (Ap(X+0.001)-Ap(X))./0.001; Cp_par_grid(:,k) = 1-Ap(XR_grid(:,k,a));
    end 
    alpha_gridf(:,:,a,i) = alpha_par_grid; C_grid(:,:,a,i) = C_par_grid; Cp_grid(:,:,a,i) = Cp_par_grid;
    for k = 1:n; if U == 1; wR_grid = w_grid(:,k,a)'; R_grid = R1_grid(:,k,a); end;
    QR_grid(k,a,i) = A_grid(k)^theta.*abs(beta*wR_grid*[Rp(R_grid,alpha_grid(a)).*Cp_grid(:,k,a,i).*up(G(i)).*up(C_grid(:,k,a,i))]+beta*wR_grid*[Rp(R_grid,alpha_grid(a)).*(1-Cp_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-C_grid(:,k,a,i)).^(-theta).*Q(XR_grid(:,k,a)-C_grid(:,k,a,i),alpha_gridf(:,k,a,i))]);
    QRa_grid(k,a,i) = A_grid(k)^(theta).*(beta*wR_grid*[A_grid(k).*(R_grid-Rf).*Cp_grid(:,k,a,i).*up(G(i)).*up(C_grid(:,k,a,i))]+beta*wR_grid*[A_grid(k).*(R_grid-Rf).*(1-Cp_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-C_grid(:,k,a,i)).^(-theta).*Q(XR_grid(:,k,a)-C_grid(:,k,a,i),alpha_gridf(:,k,a,i))]);
    psiR_grid(k,a,i) = A_grid(k)^theta.*abs(beta*wR_grid*[Rp(R_grid,alpha_grid(a)).*Cp_grid(:,k,a,i).*up(G(i)).*up(C_grid(:,k,a,i))]+beta*eta*(lambda-1)*wR_grid*[wR_grid*[(kron((Rp(R_grid,alpha_grid(a)).*Cp_grid(:,k,a,i).*up(G(i)).*up(C_grid(:,k,a,i)))',ones(m,1))-kron(Rp(R_grid,alpha_grid(a)).*Cp_grid(:,k,a,i).*up(G(i)).*up(C_grid(:,k,a,i)),ones(1,m))).*(kron(C_grid(:,k,a,i),ones(1,m))>=kron(C_grid(:,k,a,i)',ones(m,1)))]]'+beta*gamma*eta*(lambda-1)*wR_grid*[wR_grid*[(kron((Rp(R_grid,alpha_grid(a)).*(1-Cp_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-C_grid(:,k,a,i)).^(-theta).*Q(XR_grid(:,k,a)-C_grid(:,k,a,i),alpha_gridf(:,k,a,i)))',ones(m,1))-kron(Rp(R_grid,alpha_grid(a)).*(1-Cp_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-C_grid(:,k,a,i)).^(-theta).*Q(XR_grid(:,k,a)-C_grid(:,k,a,i),alpha_gridf(:,k,a,i)),ones(1,m))).*(kron(XR_grid(:,k,a)-C_grid(:,k,a,i),ones(1,m))>=kron((XR_grid(:,k,a)-C_grid(:,k,a,i))',ones(m,1)))]]'+beta*wR_grid*[Rp(R_grid,alpha_grid(a)).*(1-Cp_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-C_grid(:,k,a,i)).^(-theta).*psi(XR_grid(:,k,a)-C_grid(:,k,a,i),alpha_gridf(:,k,a,i))]);
    psiRa_grid(k,a,i) = A_grid(k)^(theta).*(beta*wR_grid*[A_grid(k).*(R_grid-Rf).*Cp_grid(:,k,a,i).*up(G(i)).*up(C_grid(:,k,a,i))]+beta*eta*(lambda-1)*wR_grid*[wR_grid*[(kron((A_grid(k).*(R_grid-Rf).*Cp_grid(:,k,a,i).*up(G(i)).*up(C_grid(:,k,a,i)))',ones(m,1))-kron(A_grid(k).*(R_grid-Rf).*Cp_grid(:,k,a,i).*up(G(i)).*up(C_grid(:,k,a,i)),ones(1,m))).*(kron(C_grid(:,k,a,i),ones(1,m))>=kron(C_grid(:,k,a,i)',ones(m,1)))]]'+beta*gamma*eta*(lambda-1)*wR_grid*[wR_grid*[(kron((A_grid(k).*(R_grid-Rf).*(1-Cp_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-C_grid(:,k,a,i)).^(-theta).*Q(XR_grid(:,k,a)-C_grid(:,k,a,i),alpha_gridf(:,k,a,i)))',ones(m,1))-kron(A_grid(k).*(R_grid-Rf).*(1-Cp_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-C_grid(:,k,a,i)).^(-theta).*Q(XR_grid(:,k,a)-C_grid(:,k,a,i),alpha_gridf(:,k,a,i)),ones(1,m))).*(kron(XR_grid(:,k,a)-C_grid(:,k,a,i),ones(1,m))>=kron((XR_grid(:,k,a)-C_grid(:,k,a,i))',ones(m,1)))]]'+beta*wR_grid*[A_grid(k).*(R_grid-Rf).*(1-Cp_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-C_grid(:,k,a,i)).^(-theta).*psi(XR_grid(:,k,a)-C_grid(:,k,a,i),alpha_gridf(:,k,a,i))]); 
    end;
end
% if i==0 && G(i)~=1; 
% Yacc = 1/Rf*ones(Ret,1); for j = 2:Ret; Yacc(j) = Yacc(j-1)*Rf+Yacc(j); end;
% for i = 1:Ret;
% for a=1:o; XR_grid(:,:,a) = kron(A_grid',ones(m,1)).*(Rf+alpha_grid(a)*kron((R_grid-Rf),ones(1,n)))./G(i); end;
% % C_grid(:,:,:,i) = C_grid(:,:,:,i).*(1+Yacc(i)./XR_grid); 
% alpha_gridf(:,:,:,i) = alpha_gridf(:,:,:,i).*(1+1./XR_grid); 
% end; alpha_gridf = min(max(alpha_gridf,0),1); 
% i = Ret; for a=1:o; XR_grid(:,:,a) = kron(A_grid',ones(m,1)).*(Rf+alpha_grid(a)*kron((R_grid-Rf),ones(1,n)))./G(i)+Yacc(Ret); end;
% psi = griddedInterpolant({[A_grid],alpha_grid},[psiR_grid(:,:,i-1)]); psi = @(A,alpha) max(psi(A,alpha),-1./psi(A,alpha));
% Q = griddedInterpolant({[A_grid],alpha_grid},[QR_grid(:,:,i-1)]); Q = @(A,alpha) max(Q(A,alpha),-1./Q(A,alpha));
% psi = griddedInterpolant({[0; A_grid; 10*A_grid(end)],alpha_grid},[psiR_grid(1,:,i-1); psiR_grid(:,:,i-1); psiR_grid(end,:,i-1)]);
% Q = griddedInterpolant({[0; A_grid; 10*A_grid(end)],alpha_grid},[QR_grid(1,:,i-1); QR_grid(:,:,i-1); QR_grid(end,:,i-1)]);
% for a = 1:o; 
%     for k = 1:n;
%     QR_grid(k,a,i) = A_grid(k)^theta.*abs(beta*wR_grid*[Rp(R_grid,alpha_grid(a)).*Cp_grid(:,k,a,i).*up(G(i)).*up(C_grid(:,k,a,i))]+beta*wR_grid*[Rp(R_grid,alpha_grid(a)).*(1-Cp_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-C_grid(:,k,a,i)).^(-theta).*Q(XR_grid(:,k,a)-C_grid(:,k,a,i),alpha_gridf(:,k,a,i))]);
%     QRa_grid(k,a,i) = A_grid(k)^(theta).*(beta*wR_grid*[A_grid(k).*(R_grid-Rf).*Cp_grid(:,k,a,i).*up(G(i)).*up(C_grid(:,k,a,i))]+beta*wR_grid*[A_grid(k).*(R_grid-Rf).*(1-Cp_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-C_grid(:,k,a,i)).^(-theta).*Q(XR_grid(:,k,a)-C_grid(:,k,a,i),alpha_gridf(:,k,a,i))]);
%     psiR_grid(k,a,i) = A_grid(k)^theta.*abs(beta*wR_grid*[Rp(R_grid,alpha_grid(a)).*Cp_grid(:,k,a,i).*up(G(i)).*up(C_grid(:,k,a,i))]+beta*eta*(lambda-1)*wR_grid*[wR_grid*[(kron((Rp(R_grid,alpha_grid(a)).*Cp_grid(:,k,a,i).*up(G(i)).*up(C_grid(:,k,a,i)))',ones(m,1))-kron(Rp(R_grid,alpha_grid(a)).*Cp_grid(:,k,a,i).*up(G(i)).*up(C_grid(:,k,a,i)),ones(1,m))).*(kron(C_grid(:,k,a,i),ones(1,m))>=kron(C_grid(:,k,a,i)',ones(m,1)))]]'+beta*gamma*eta*(lambda-1)*wR_grid*[wR_grid*[(kron((Rp(R_grid,alpha_grid(a)).*(1-Cp_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-C_grid(:,k,a,i)).^(-theta).*Q(XR_grid(:,k,a)-C_grid(:,k,a,i),alpha_gridf(:,k,a,i)))',ones(m,1))-kron(Rp(R_grid,alpha_grid(a)).*(1-Cp_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-C_grid(:,k,a,i)).^(-theta).*Q(XR_grid(:,k,a)-C_grid(:,k,a,i),alpha_gridf(:,k,a,i)),ones(1,m))).*(kron(XR_grid(:,k,a)-C_grid(:,k,a,i),ones(1,m))>=kron((XR_grid(:,k,a)-C_grid(:,k,a,i))',ones(m,1)))]]'+beta*wR_grid*[Rp(R_grid,alpha_grid(a)).*(1-Cp_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-C_grid(:,k,a,i)).^(-theta).*psi(XR_grid(:,k,a)-C_grid(:,k,a,i),alpha_gridf(:,k,a,i))]);
%     psiRa_grid(k,a,i) = A_grid(k)^(theta).*(beta*wR_grid*[A_grid(k).*(R_grid-Rf).*Cp_grid(:,k,a,i).*up(G(i)).*up(C_grid(:,k,a,i))]+beta*eta*(lambda-1)*wR_grid*[wR_grid*[(kron((A_grid(k).*(R_grid-Rf).*Cp_grid(:,k,a,i).*up(G(i)).*up(C_grid(:,k,a,i)))',ones(m,1))-kron(A_grid(k).*(R_grid-Rf).*Cp_grid(:,k,a,i).*up(G(i)).*up(C_grid(:,k,a,i)),ones(1,m))).*(kron(C_grid(:,k,a,i),ones(1,m))>=kron(C_grid(:,k,a,i)',ones(m,1)))]]'+beta*gamma*eta*(lambda-1)*wR_grid*[wR_grid*[(kron((A_grid(k).*(R_grid-Rf).*(1-Cp_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-C_grid(:,k,a,i)).^(-theta).*Q(XR_grid(:,k,a)-C_grid(:,k,a,i),alpha_gridf(:,k,a,i)))',ones(m,1))-kron(A_grid(k).*(R_grid-Rf).*(1-Cp_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-C_grid(:,k,a,i)).^(-theta).*Q(XR_grid(:,k,a)-C_grid(:,k,a,i),alpha_gridf(:,k,a,i)),ones(1,m))).*(kron(XR_grid(:,k,a)-C_grid(:,k,a,i),ones(1,m))>=kron((XR_grid(:,k,a)-C_grid(:,k,a,i))',ones(m,1)))]]'+beta*wR_grid*[A_grid(k).*(R_grid-Rf).*(1-Cp_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-C_grid(:,k,a,i)).^(-theta).*psi(XR_grid(:,k,a)-C_grid(:,k,a,i),alpha_gridf(:,k,a,i))]);
%     end;
% end
% end
% end
